VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_circle_circle_tangents"
   ClientHeight    =   4485
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4875
   LinkTopic       =   "Form1"
   ScaleHeight     =   4485
   ScaleWidth      =   4875
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The point where the user pressed the mouse.
Private StartPoint As PointF

' The mouse's current point.
Private CurrentPoint As PointF

Private Sub Form_Load()
    Set StartPoint = New PointF
    StartPoint.X = -1
    StartPoint.Y = -1

    Set CurrentPoint = New PointF
    CurrentPoint.X = -1
    CurrentPoint.Y = -1

    Me.ScaleMode = vbPixels
End Sub

Private Sub Form_Resize()
    Me.Refresh
End Sub

' Record the starting point.
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Save the point.
    StartPoint.X = X
    StartPoint.Y = Y
    CurrentPoint.X = X
    CurrentPoint.Y = Y

    ' Redraw.
    Me.Refresh
End Sub

' If the left mouse button is down, move the current point.
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If (Button = vbLeftButton) Then
        CurrentPoint.X = X
        CurrentPoint.Y = Y
        Me.Refresh
    End If
End Sub

' Draw the circle, point, and tangent lines.
Private Sub Form_Paint()
Dim dx As Single
Dim dy As Single
Dim center1 As PointF
Dim center2 As PointF
Dim radius1 As Single
Dim radius2 As Single
Dim outer1_p1 As PointF
Dim outer1_p2 As PointF
Dim outer2_p1 As PointF
Dim outer2_p2 As PointF
Dim inner1_p1 As PointF
Dim inner1_p2 As PointF
Dim inner2_p1 As PointF
Dim inner2_p2 As PointF
Dim num_tangents As Integer

    ' Draw the first circle.
    If Me.ScaleWidth > Me.ScaleHeight Then
        radius1 = Me.ScaleHeight / 4
    Else
        radius1 = Me.ScaleWidth / 4
    End If
    Set center1 = New PointF
    center1.X = Me.ScaleWidth - radius1 - 20
    center1.Y = Me.ScaleHeight - radius1 - 20
    Me.Circle (center1.X, center1.Y), radius1, vbBlue

    If (StartPoint.X < 0) Then Exit Sub

    ' Get the second circle's geometry.
    dx = StartPoint.X - CurrentPoint.X
    dy = StartPoint.Y - CurrentPoint.Y
    radius2 = CSng(Sqr(dx * dx + dy * dy))

    ' Find the tangents.
    num_tangents = FindCircleCircleTangents( _
        center1, radius1, _
        StartPoint, radius2, _
        outer1_p1, outer1_p2, _
        outer2_p1, outer2_p2, _
        inner1_p1, inner1_p2, _
        inner2_p1, inner2_p2)

    If (num_tangents > 0) Then
        Debug.Print outer1_p1.ToString

        ' Draw the outer tangents.
        Me.Line (outer1_p1.X, outer1_p1.Y)-(outer1_p2.X, outer1_p2.Y), vbBlue
        Me.Line (outer2_p1.X, outer2_p1.Y)-(outer2_p2.X, outer2_p2.Y), vbBlue

        If (num_tangents > 2) Then
            ' Draw the inner tangents.
            Me.Line (inner1_p1.X, inner1_p1.Y)-(inner1_p2.X, inner1_p2.Y), vbRed
            Me.Line (inner2_p1.X, inner2_p1.Y)-(inner2_p2.X, inner2_p2.Y), vbRed
        End If
    End If

    ' Draw the second circle.
    Me.Circle (StartPoint.X, StartPoint.Y), radius2, vbRed
End Sub
